<script setup lang="ts">
import { useRouter, useRoute } from 'vue-router';
import { reactive, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { ProModal } from 'antdv-pro-modal';
import { message, Modal, Form } from 'ant-design-vue/es';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/es/table';
import {
  exportJob,
  listJob,
  getJob,
  delJob,
  addJob,
  updateJob,
  runJob,
  changeJobStatus,
  resetQueueJob,
} from '@/api/monitor/job';
import { saveAs } from 'file-saver';
import { parseDateToStr } from '@/utils/date-utils';
import useDictStore from '@/store/modules/dict';
import { hasPermissions } from '@/plugins/auth-user';
import { MENU_PATH_INLINE } from '@/constants/menu-constants';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useI18n from '@/hooks/useI18n';
const { t } = useI18n();
const { getDict } = useDictStore();
const router = useRouter();
const route = useRoute();
const routePath = route.path;

/**字典数据 */
let dict: {
  /**任务组名 */
  sysJobGroup: DictType[];
  /**任务状态 */
  sysJobStatus: DictType[];
  /**任务记录日志 */
  sysJobSaveLog: DictType[];
} = reactive({
  sysJobGroup: [],
  sysJobStatus: [],
  sysJobSaveLog: [],
});

/**查询参数 */
let queryParams = reactive({
  /**任务名称 */
  jobName: '',
  /**任务组名 */
  jobGroup: undefined,
  /**任务状态 */
  status: undefined,
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    jobName: '',
    jobGroup: undefined,
    status: undefined,
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: false,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('common.rowId'),
    dataIndex: 'jobId',
    align: 'center',
  },
  {
    title: t('views.monitor.job.jobName'),
    dataIndex: 'jobName',
    align: 'left',
    width: 200,
  },
  {
    title: t('views.monitor.job.jobGroup'),
    dataIndex: 'jobGroup',
    key: 'jobGroup',
    align: 'center',
    width: 100,
  },
  {
    title: t('views.monitor.job.invokeTarget'),
    dataIndex: 'invokeTarget',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.monitor.job.cronExpression'),
    dataIndex: 'cronExpression',
    align: 'left',
    width: 100,
  },
  {
    title: t('views.monitor.job.status'),
    dataIndex: 'status',
    key: 'status',
    align: 'center',
    width: 100,
  },
  {
    title: t('views.monitor.job.saveLog'),
    dataIndex: 'saveLog',
    key: 'saveLog',
    align: 'center',
    width: 100,
  },
  {
    title: t('common.operate'),
    key: 'jobId',
    align: 'left',
  },
];

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) =>
    t('common.tablePaginationTotal', { total: total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格多选 */
function fnTableSelectedRowKeys(keys: (string | number)[]) {
  tableState.selectedRowKeys = keys;
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**详情框是否显示 */
  openByView: boolean;
  /**新增框或修改框是否显示 */
  openByEdit: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
  /**cron生成框是否显示 */
  openByCron: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  openByView: false,
  openByEdit: false,
  title: '任务',
  from: {
    jobId: undefined,
    jobName: '',
    invokeTarget: '',
    cronExpression: '',
    misfirePolicy: '3',
    concurrent: '0',
    jobGroup: 'DEFAULT',
    status: '0',
    saveLog: '0',
    targetParams: '',
    remark: '',
  },
  confirmLoading: false,
  openByCron: false,
});

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    jobName: [
      {
        required: true,
        min: 2,
        max: 50,
        message: t('views.monitor.job.jobNamePlease'),
      },
    ],
    invokeTarget: [
      {
        required: true,
        min: 2,
        max: 50,
        message: t('views.monitor.job.invokeTargetPlease'),
      },
    ],
    cronExpression: [
      {
        required: true,
        min: 6,
        message: t('views.monitor.job.cronExpressionPlease'),
      },
    ],
  })
);

/**
 * 对话框弹出显示为 查看
 * @param jobId 任务id
 */
function fnModalVisibleByVive(jobId: string | number) {
  if (!jobId) {
    message.error(t('views.monitor.job.tipRowErr'), 2);
    return;
  }
  if (modalState.confirmLoading) return;
  const hide = message.loading(t('common.loading'), 0);
  modalState.confirmLoading = true;
  getJob(jobId).then(res => {
    modalState.confirmLoading = false;
    hide();
    if (res.code === RESULT_CODE_SUCCESS && res.data) {
      modalState.from = Object.assign(modalState.from, res.data);
      modalState.title = t('views.monitor.job.viewJob');
      modalState.openByView = true;
    } else {
      message.error(t('views.monitor.job.viewInfoErr'), 2);
    }
  });
}

/**
 * 对话框弹出显示为 新增或者修改
 * @param jobId 任务id, 不传为新增
 */
function fnModalVisibleByEdit(jobId?: string | number) {
  if (!jobId) {
    modalStateFrom.resetFields();
    modalState.title = t('views.monitor.job.addJob');
    modalState.openByEdit = true;
  } else {
    if (modalState.confirmLoading) return;
    const hide = message.loading(t('common.loading'), 0);
    modalState.confirmLoading = true;
    getJob(jobId).then(res => {
      modalState.confirmLoading = false;
      hide();
      if (res.code === RESULT_CODE_SUCCESS && res.data) {
        modalState.from = Object.assign(modalState.from, res.data);
        modalState.title = t('views.monitor.job.editJob');
        modalState.openByEdit = true;
      } else {
        message.error(t('views.monitor.job.viewInfoErr'), 2);
      }
    });
  }
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  modalStateFrom
    .validate()
    .then(() => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.from);
      const job = from.jobId ? updateJob(from) : addJob(from);
      const key = 'job';
      message.loading({ content: t('common.loading'), key });
      job
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              key,
              duration: 2,
            });
            modalState.openByEdit = false;
            modalStateFrom.resetFields();
            fnGetList(1);
          } else {
            message.error({
              content: `${res.msg}`,
              key,
              duration: 2,
            });
          }
        })
        .finally(() => {
          modalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.openByEdit = false;
  modalState.openByView = false;
  modalStateFrom.resetFields();
}

/**
 * 对话框弹出cron生成回调
 */
function fnModalCron(opt: boolean, cronStr?: string) {
  modalState.openByCron = opt;
  if (cronStr) {
    modalState.from.cronExpression = cronStr;
  }
}

/**
 * 任务状态修改
 * @param row 任务信息对象
 */
function fnRecordStatus(row: Record<string, string>) {
  const text =
    row.status === '1'
      ? dict.sysJobStatus.find(s => s.value === '1')?.label
      : dict.sysJobStatus.find(s => s.value === '0')?.label;
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.monitor.job.statusChange', { text, num: row.jobName }),
    onOk() {
      const key = 'changeJobStatus';
      message.loading({ content: t('common.loading'), key });
      changeJobStatus(row.jobId, row.status).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('common.msgSuccess', { msg: `${row.jobName} ${text}` }),
            key,
            duration: 2,
          });
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 2,
          });
        }
        fnGetList();
      });
    },
    onCancel() {
      const value =
        row.status === '1'
          ? dict.sysJobStatus.find(s => s.value === '0')?.value
          : dict.sysJobStatus.find(s => s.value === '1')?.value;
      row.status = value || '0';
    },
  });
}

/**
 * 任务立即执行一次
 * @param row 任务信息对象
 */
function fnRecordRunOne(row: Record<string, string>) {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.monitor.job.runOneTip', { num: row.jobName }),
    onOk() {
      const key = 'runJob';
      message.loading({ content: t('common.loading'), key });
      runJob(row.jobId).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('views.monitor.job.runOneOk', { num: row.jobName }),
            key,
            duration: 2,
          });
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**
 * 任务删除
 * @param jobId 任务编号ID
 */
function fnRecordDelete(jobId: string = '0') {
  if (jobId === '0') {
    jobId = tableState.selectedRowKeys.join(',');
  }
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.monitor.job.runOneTip', { num: jobId }),
    onOk() {
      const key = 'delJob';
      message.loading({ content: t('common.loading'), key });
      delJob(jobId).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('views.monitor.job.delOk'),
            key,
            duration: 2,
          });
          fnGetList();
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**
 * 重置刷新队列
 */
function fnResetQueueJob() {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.monitor.job.resetTip'),
    onOk() {
      const key = 'resetQueueJob';
      message.loading({ content: t('common.loading'), key });
      resetQueueJob().then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('views.monitor.job.resetOk'),
            key,
            duration: 2,
          });
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**列表导出 */
function fnExportList() {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.monitor.job.exportTip'),
    onOk() {
      const key = 'exportJob';
      message.loading({ content: t('common.loading'), key });
      exportJob(toRaw(queryParams)).then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          message.success({
            content: t('views.monitor.job.exportOk'),
            key,
            duration: 2,
          });
          saveAs(res.data, `job_${Date.now()}.xlsx`);
        } else {
          message.error({
            content: `${res.msg}`,
            key,
            duration: 2,
          });
        }
      });
    },
  });
}

/**跳转任务日志页面 */
function fnJobLogView(jobId: string | number = '0') {
  router.push(`${routePath}${MENU_PATH_INLINE}/log/${jobId}`);
}

/**查询定时任务列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
  }
  listJob(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      tablePagination.total = res.total;
      tableState.data = res.rows;
      if (
        tablePagination.total <=
          (queryParams.pageNum - 1) * tablePagination.pageSize &&
        queryParams.pageNum !== 1
      ) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    }
    tableState.loading = false;
  });
}

onMounted(() => {
  // 初始字典数据
  Promise.allSettled([
    getDict('sys_job_group'),
    getDict('sys_job_status'),
    getDict('sys_job_save_log'),
  ]).then(resArr => {
    if (resArr[0].status === 'fulfilled') {
      dict.sysJobGroup = resArr[0].value;
    }
    if (resArr[1].status === 'fulfilled') {
      dict.sysJobStatus = resArr[1].value;
    }
    if (resArr[2].status === 'fulfilled') {
      dict.sysJobSaveLog = resArr[2].value;
    }
  });
  // 获取列表数据
  fnGetList();
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.monitor.job.jobName')" name="jobName">
              <a-input
                v-model:value="queryParams.jobName"
                allow-clear
                :placeholder="t('views.monitor.job.jobNamePlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.monitor.job.jobGroup')"
              name="jobGroup"
            >
              <a-select
                v-model:value="queryParams.jobGroup"
                allow-clear
                :placeholder="t('common.selectPlease')"
                :options="dict.sysJobGroup"
              >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.monitor.job.status')" name="status">
              <a-select
                v-model:value="queryParams.status"
                allow-clear
                :placeholder="t('common.selectPlease')"
                :options="dict.sysJobStatus"
              >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <a-space :size="8" align="center">
          <a-button
            type="primary"
            @click.prevent="fnModalVisibleByEdit()"
            v-perms:has="['monitor:job:add']"
          >
            <template #icon><PlusOutlined /></template>
            {{ t('common.addText') }}
          </a-button>
          <a-button
            type="default"
            danger
            :disabled="tableState.selectedRowKeys.length <= 0"
            @click.prevent="fnRecordDelete()"
            v-perms:has="['monitor:job:remove']"
          >
            <template #icon><DeleteOutlined /></template>
            {{ t('common.deleteText') }}
          </a-button>
          <a-button
            type="dashed"
            @click.prevent="fnExportList()"
            v-perms:has="['monitor:job:export']"
          >
            <template #icon><ExportOutlined /></template>
            {{ t('common.export') }}
          </a-button>
          <a-button
            type="default"
            @click.prevent="fnJobLogView()"
            v-perms:has="['monitor:job:query']"
          >
            <template #icon><ContainerOutlined /></template>
            {{ t('views.monitor.job.jobLog') }}
          </a-button>
          <a-button
            type="dashed"
            danger
            @click.prevent="fnResetQueueJob"
            v-perms:has="['monitor:job:remove']"
          >
            <template #icon><SyncOutlined /></template>
            {{ t('views.monitor.job.resetQueue') }}
          </a-button>
        </a-space>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="jobId"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: tableColumns.length * 120 }"
        :row-selection="{
          type: 'checkbox',
          selectedRowKeys: tableState.selectedRowKeys,
          onChange: fnTableSelectedRowKeys,
        }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'jobGroup'">
            <DictTag :options="dict.sysJobGroup" :value="record.jobGroup" />
          </template>
          <template v-if="column.key === 'status'">
            <a-switch
              v-if="
                dict.sysJobStatus.length > 0 &&
                hasPermissions(['monitor:job:changeStatus'])
              "
              v-model:checked="record.status"
              checked-value="1"
              :checked-children="dict.sysJobStatus[0].label"
              un-checked-value="0"
              :un-checked-children="dict.sysJobStatus[1].label"
              size="small"
              @change="fnRecordStatus(record)"
            />
            <DictTag
              v-else
              :options="dict.sysJobStatus"
              :value="record.status"
            />
          </template>
          <template v-if="column.key === 'saveLog'">
            <DictTag :options="dict.sysJobSaveLog" :value="record.saveLog" />
          </template>
          <template v-if="column.key === 'jobId'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.viewText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByVive(record.jobId)"
                  v-perms:has="['monitor:job:query']"
                >
                  <template #icon><ProfileOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record.jobId)"
                  v-perms:has="['monitor:job:edit']"
                >
                  <template #icon><FormOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordDelete(record.jobId)"
                  v-perms:has="['monitor:job:remove']"
                >
                  <template #icon><DeleteOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('views.monitor.job.runOne') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordRunOne(record)"
                  v-perms:has="['monitor:job:changeStatus']"
                >
                  <template #icon><RocketOutlined /></template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('views.monitor.job.jobLog') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnJobLogView(record.jobId)"
                  v-perms:has="['monitor:job:log']"
                >
                  <template #icon><ContainerOutlined /></template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 详情框 -->
    <ProModal
      :drag="true"
      :width="800"
      :open="modalState.openByView"
      :title="modalState.title"
      @cancel="fnModalCancel"
    >
      <a-form layout="horizontal" :label-col="{ span: 6 }" :label-wrap="true">
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item :label="t('views.monitor.job.jobName')" name="jobName">
              {{ modalState.from.jobName }}
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item :label="t('views.monitor.job.status')" name="status">
              {{
                dict.sysJobStatus.find(s => s.value === modalState.from.status)
                  ?.label
              }}
            </a-form-item>
          </a-col>
        </a-row>

        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.monitor.job.invokeTarget')"
              name="invokeTarget"
            >
              {{ modalState.from.invokeTarget }}
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.monitor.job.jobGroup')"
              name="jobGroup"
            >
              <DictTag
                :options="dict.sysJobGroup"
                :value="modalState.from.jobGroup"
              />
            </a-form-item>
          </a-col>
        </a-row>

        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.monitor.job.cronExpression')"
              name="cronExpression"
            >
              <a-tag color="default">
                {{ modalState.from.cronExpression }}
              </a-tag>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item :label="t('views.monitor.job.saveLog')" name="saveLog">
              <DictTag
                :options="dict.sysJobSaveLog"
                :value="modalState.from.saveLog"
              />
            </a-form-item>
          </a-col>
        </a-row>

        <a-form-item
          :label="t('views.monitor.job.createTime')"
          name="createTime"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <span v-if="+modalState.from.createTime > 0">
            {{ parseDateToStr(+modalState.from.createTime) }}
          </span>
        </a-form-item>

        <a-form-item
          :label="t('views.monitor.job.targetParams')"
          name="targetParams"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-textarea
            v-model:value="modalState.from.targetParams"
            :auto-size="{ minRows: 2, maxRows: 6 }"
            :disabled="true"
          />
        </a-form-item>

        <a-form-item
          :label="t('views.monitor.job.remark')"
          name="remark"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-textarea
            v-model:value="modalState.from.remark"
            :auto-size="{ minRows: 2, maxRows: 6 }"
            :disabled="true"
          />
        </a-form-item>
      </a-form>
      <template #footer>
        <a-button key="cancel" @click="fnModalCancel">
          {{ t('common.close') }}
        </a-button>
      </template>
    </ProModal>

    <!-- 新增框或修改框 -->
    <ProModal
      :drag="true"
      :width="800"
      :destroyOnClose="true"
      :keyboard="false"
      :mask-closable="false"
      :open="modalState.openByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFrom"
        layout="horizontal"
        :label-col="{ span: 6 }"
        :label-wrap="true"
      >
        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.monitor.job.jobName')"
              name="jobName"
              v-bind="modalStateFrom.validateInfos.jobName"
            >
              <a-input
                v-model:value="modalState.from.jobName"
                allow-clear
                :placeholder="t('views.monitor.job.jobNamePlease')"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item :label="t('views.monitor.job.status')" name="status">
              <a-select
                v-model:value="modalState.from.status"
                default-value="0"
                :placeholder="t('common.selectPlease')"
                :options="dict.sysJobStatus"
              >
              </a-select>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.monitor.job.jobGroup')"
              name="jobGroup"
            >
              <a-select
                v-model:value="modalState.from.jobGroup"
                default-value="DEFAULT"
                :placeholder="t('common.selectPlease')"
                :options="dict.sysJobGroup"
              >
              </a-select>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item :label="t('views.monitor.job.saveLog')" name="saveLog">
              <a-select
                v-model:value="modalState.from.saveLog"
                default-value="0"
                :placeholder="t('common.selectPlease')"
                :options="dict.sysJobSaveLog"
              >
              </a-select>
            </a-form-item>
          </a-col>
        </a-row>

        <a-form-item
          :label="t('views.monitor.job.invokeTarget')"
          name="invokeTarget"
          v-bind="modalStateFrom.validateInfos.invokeTarget"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-input
            v-model:value="modalState.from.invokeTarget"
            allow-clear
            :placeholder="t('views.monitor.job.invokeTargetPlease')"
          >
            <template #prefix>
              <a-tooltip placement="topLeft">
                <template #title>
                  <div>{{ t('views.monitor.job.invokeTargetTip') }}</div>
                </template>
                <InfoCircleOutlined style="opacity: 0.45; color: inherit" />
              </a-tooltip>
            </template>
          </a-input>
        </a-form-item>

        <a-form-item
          :label="t('views.monitor.job.cronExpression')"
          name="cronExpression"
          v-bind="modalStateFrom.validateInfos.cronExpression"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-input
            v-model:value="modalState.from.cronExpression"
            allow-clear
            :placeholder="t('views.monitor.job.cronExpressionPlease')"
          >
            <template #prefix>
              <a-tooltip placement="topLeft">
                <template #title>
                  <div>
                    {{ t('views.monitor.job.cronExpressionTip') }}<br />
                    {{ t('views.monitor.job.cronExpressionTip1') }}
                  </div>
                </template>
                <InfoCircleOutlined style="opacity: 0.45; color: inherit" />
              </a-tooltip>
            </template>
            <template #addonAfter>
              <a-button
                type="text"
                size="small"
                @click.prevent="fnModalCron(true)"
              >
                <template #icon><FieldTimeOutlined /></template>
                {{ t('views.monitor.job.cronExpressionNew') }}
              </a-button>
            </template>
          </a-input>
        </a-form-item>

        <a-form-item
          :label="t('views.monitor.job.targetParams')"
          name="targetParams"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-textarea
            v-model:value="modalState.from.targetParams"
            :auto-size="{ minRows: 2, maxRows: 6 }"
            :maxlength="400"
            :placeholder="t('views.monitor.job.targetParamsPlease')"
          />
        </a-form-item>

        <a-form-item
          :label="t('views.monitor.job.remark')"
          name="remark"
          :label-col="{ span: 3 }"
          :label-wrap="true"
        >
          <a-textarea
            v-model:value="modalState.from.remark"
            :auto-size="{ minRows: 2, maxRows: 6 }"
            :maxlength="400"
            :show-count="true"
          />
        </a-form-item>
      </a-form>
    </ProModal>

    <!-- 生成cron表达式 -->
    <CronModal
      v-model:open="modalState.openByCron"
      :cron="modalState.from.cronExpression"
      @ok="fnModalCron(false, $event)"
    ></CronModal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
